# AutoNap.pl - an automatizable Napster/OpenNap client
# Copyright (C) 2001  Tassilo v. Parseval
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# AutoNap caching module $Revision: 1.6 $
# last change made $Date: 2001/05/15 06:07:39 $

package AutoLib::Cache;

BEGIN {
	use Exporter   ();
	use vars       qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);

	$VERSION = 0.1.2;

	@ISA          = qw(Exporter);
	@EXPORT       = qw(@CACHE_BROWSE   @CACHE_SEARCH 
					   &cache_browse   &cache_search
					   &get_from_cache
					   &num_of_browse  &num_of_search);
	%EXPORT_TAGS  = ();

	}
	
use strict;
use vars     @EXPORT_OK;


our (@CACHE_SEARCH, @CACHE_BROWSE);

sub cache_search {

	my @s = @_;

	# destroy oldest element of cache if there are already 
	# ten cached searches
	
	shift @CACHE_SEARCH unless num_of_search() < 10;
	push @CACHE_SEARCH, [ @s ];

}

sub cache_browse {

	my @b = @_;

	# destroy oldest element of cache
	shift @CACHE_BROWSE unless num_of_browse() < 10;
	
	push @CACHE_BROWSE, [ @b ];

}

sub get_from_cache {

	my ($type, $n) = @_;
		
	# reference to array
	my $ret;
	
	$ret = $CACHE_SEARCH[$n] if $type eq 'search';
	$ret = $CACHE_BROWSE[$n] if $type eq 'browse';
	
	return @$ret;
	
}
	
sub num_of_search {
	return my $n = @CACHE_SEARCH;
}

sub num_of_browse {
	return my $n = @CACHE_BROWSE;
}
	
	
1;
