# AutoNap.pl - an automatizable Napster/OpenNap client
# Copyright (C) 2001  Tassilo v. Parseval
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# AutoNap callback module $Revision: 1.8 $
# last change made $Date: 2001/05/15 06:07:39 $

import MP3::Napster;

package AutoLib::Callbacks;

BEGIN {
	use Exporter   ();
	use vars       qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);

	$VERSION = 1.0;

	@ISA          = qw(Exporter);
	@EXPORT       = qw(&set_CLB_output_handle
					   &CLB_message_of_day
			           &CLB_transfer_progress 
			           &CLB_transfer_start 
					   &CLB_transfer_end 
					   &CLB_transfer_status
					   &print_MOTD);
	%EXPORT_TAGS  = ( );
	

	}

use Term::ANSIColor qw (:constants);
use strict;
use vars     @EXPORT_OK;


our ($MOTD, $OUT);


sub set_CLB_output_handle {
	$OUT = shift;
}

sub CLB_message_of_day {
	my ($nap, $code, $msg) = @_;
	$MOTD = sprintf defined $msg ? BLUE."// ".GREEN.$msg.RESET."\n" : 
				       BLUE." \n// ".RED."No Message of the Day today".RESET;
	print_MOTD();
}

sub CLB_transfer_progress {
	my ($nap, $code, $trans) = @_;
	printf $OUT "Download of ".$trans->asString()." still running...\n";
}

sub CLB_transfer_start {
	my ($nap, $code, $trans) = @_;
	printf $OUT BLUE."******\n";
	printf $OUT GREEN."Download: ".$trans->asString()." started...";
	printf $OUT BLUE."\n******".RESET."\n";
}

sub CLB_transfer_end {
	my ($nap, $code, $trans) = @_;
	printf $OUT BLUE."*****\n";
	if ($trans->status eq 'transfer aborted') {	
		printf $OUT BOLD.RED."Download: ".$trans->asString()." aborted.";
	}
	else {
		printf $OUT GREEN."Download: ".$trans->asString()." finished: ".
				  $trans->transferred." of ".$trans->size. "bytes";
	}
	printf $OUT RESET.BLUE."\n*****".RESET."\n";
}

sub CLB_transfer_status {
	my ($nap, $code, $trans) = @_;
}

sub print_MOTD {
	print $OUT $MOTD;
}

1;
