# AutoNap.pl - an automatizable Napster/OpenNap client
# Copyright (C) 2001  Tassilo v. Parseval
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# AutoNap trapping module $Revision: 1.5 $
# last change made $Date: 2001/05/15 06:07:39 $
# Needed basically, to turn trapping off
# if it gets in the way

package AutoLib::Trap;

BEGIN {
	use Exporter   ();
	use vars       qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);

	$VERSION = 1.0;

	@ISA          = qw(Exporter);
	@EXPORT       = qw();
	%EXPORT_TAGS  = ();

	}
	
use strict;
use Term::ANSIColor qw(:constants);
use vars     @EXPORT_OK;

#-------------------------------
# we don't want warnings either
#-------------------------------

$SIG{__WARN__} = sub {
	printf BOLD.RED.
		"Sorry: This is not possible and a warning has been raised.\n".
	    "Copy message into an email to <Tassilo.Parseval\@".
		"post.rwth-aachen.de>\nfor reporting this since such a thing".
		" shouldn't happen and please\nadd a short description".
		" which action you just performed:\n".
	    YELLOW.$_[0].RESET."\n";
};

#--------------------------------------------------
# we need to trap die()ings definiteley 
#--------------------------------------------------

$SIG{__DIE__} =	sub {
	printf BOLD.RED.
		"Sorry: A serious error occured and it has been fatal.\n".
	    "Copy message into an email to <Tassilo.Parseval\@".
		"post.rwth-aachen.de>\nfor reporting this since such a thing".
		" really shouldn't happen and please\nadd a short description".
		" which action you just performed:\n".
	    YELLOW.$_[0].RESET."\n"; 
};

#---------------------------------
# mandatory for 'no AutoLib::Trap'
#---------------------------------

sub unimport {
	shift;
	$SIG{__WARN__} = sub { };
	$SIG{__DIE__}  = sub { };
}
1;

